diff --git openjdk-orig/hotspot/lsb/static/freetype_impl.c openjdk/hotspot/lsb/static/freetype_impl.c
new file mode 100644
index 0000000..ffa42c1
--- /dev/null
+++ openjdk/hotspot/lsb/static/freetype_impl.c
@@ -0,0 +1,279 @@
+
+
+/* File that implements a couple of Freetype functions that
+   are not in LSB but are used in OpenJDK 7 */
+
+// Includes that define types and functions implemented
+
+#include <ft2build.h>
+#include FT_FREETYPE_H
+#include FT_TRIGONOMETRY_H
+#include FT_BITMAP_H
+#include FT_GLYPH_H
+
+#include "lsb_freetype.h"
+
+#include <lsb_config.h>
+
+  FT_Error
+  FT_Outline_Embolden( FT_Outline*  outline,
+                       FT_Pos       strength );
+#ifdef __LSB_PROVIDES_FT_GlyphSlot_Embolden
+  FT_Error
+  FT_GlyphSlot_Own_Bitmap( FT_GlyphSlot  slot );
+#endif
+
+#ifdef __LSB_PROVIDES_FT_GlyphSlot_Embolden
+  void
+  FT_GlyphSlot_Embolden( FT_GlyphSlot  slot )
+  {
+    FT_Library  library = slot->library;
+    FT_Face     face    = slot->face;
+    FT_Error    error;
+    FT_Pos      xstr, ystr;
+
+
+    if ( slot->format != FT_GLYPH_FORMAT_OUTLINE &&
+         slot->format != FT_GLYPH_FORMAT_BITMAP )
+      return;
+
+    /* some reasonable strength */
+    xstr = FT_MulFix( face->units_per_EM,
+                      face->size->metrics.y_scale ) / 24;
+    ystr = xstr;
+
+    if ( slot->format == FT_GLYPH_FORMAT_OUTLINE )
+    {
+      error = FT_Outline_Embolden( &slot->outline, xstr );
+      /* ignore error */
+
+      /* this is more than enough for most glyphs; if you need accurate */
+      /* values, you have to call FT_Outline_Get_CBox                   */
+      xstr = xstr * 2;
+      ystr = xstr;
+    }
+    else if ( slot->format == FT_GLYPH_FORMAT_BITMAP )
+    {
+      /* round to full pixels */
+      xstr &= ~63;
+      if ( xstr == 0 )
+        xstr = 1 << 6;
+      ystr &= ~63;
+
+      error = FT_GlyphSlot_Own_Bitmap( slot );
+      if ( error )
+        return;
+
+      error = FT_Bitmap_Embolden( library, &slot->bitmap, xstr, ystr );
+      if ( error )
+        return;
+    }
+
+    if ( slot->advance.x )
+      slot->advance.x += xstr;
+
+    if ( slot->advance.y )
+      slot->advance.y += ystr;
+
+    slot->metrics.width        += xstr;
+    slot->metrics.height       += ystr;
+    slot->metrics.horiBearingY += ystr;
+    slot->metrics.horiAdvance  += xstr;
+    slot->metrics.vertBearingX -= xstr / 2;
+    slot->metrics.vertBearingY += ystr;
+    slot->metrics.vertAdvance  += ystr;
+
+    if ( slot->format == FT_GLYPH_FORMAT_BITMAP )
+      slot->bitmap_top += ystr >> 6;
+  }
+#endif
+
+#ifdef __LSB_PROVIDES_FT_GlyphSlot_Oblique
+  void
+  FT_GlyphSlot_Oblique( FT_GlyphSlot  slot )
+  {
+    FT_Matrix    transform;
+    FT_Outline*  outline = &slot->outline;
+
+
+    /* only oblique outline glyphs */
+    if ( slot->format != FT_GLYPH_FORMAT_OUTLINE )
+      return;
+
+    /* we don't touch the advance width */
+
+    /* For italic, simply apply a shear transform, with an angle */
+    /* of about 12 degrees.                                      */
+
+    transform.xx = 0x10000L;
+    transform.yx = 0x00000L;
+
+    transform.xy = 0x06000L;
+    transform.yy = 0x10000L;
+
+    FT_Outline_Transform( outline, &transform );
+  }
+#endif
+
+
+  /* We encarve this internal structure here because, in order to retain
+     binary compatibility, Freetype developers will keep at least these fields
+     unchanged. */
+  typedef struct  FT_GlyphLoadRec_
+  {
+    FT_Outline   outline;       /* outline                   */
+    FT_Vector*   extra_points;  /* extra points table        */
+    FT_Vector*   extra_points2; /* second extra points table */
+    FT_UInt      num_subglyphs; /* number of subglyphs       */
+    FT_SubGlyph  subglyphs;     /* subglyphs                 */
+
+  } FT_GlyphLoadRec, *FT_GlyphLoad;
+
+  typedef struct  FT_GlyphLoaderRec_
+  {
+    FT_Memory        memory;
+    FT_UInt          max_points;
+    FT_UInt          max_contours;
+    FT_UInt          max_subglyphs;
+    FT_Bool          use_extra;
+
+    FT_GlyphLoadRec  base;
+    FT_GlyphLoadRec  current;
+
+    void*            other;            /* for possible future extension? */
+
+  } FT_GlyphLoaderRec;
+    typedef struct FT_GlyphLoaderRec_*  FT_GlyphLoader ;
+
+#define FT_GLYPH_OWN_BITMAP  0x1
+
+  typedef struct  FT_Slot_InternalRec_  
+  { 
+    FT_GlyphLoader  loader; 
+    FT_UInt         flags; 
+    FT_Bool         glyph_transformed; 
+    FT_Matrix       glyph_matrix; 
+    FT_Vector       glyph_delta; 
+    void*           glyph_hints; 
+  } FT_GlyphSlot_InternalRec; 
+
+
+#ifdef __LSB_PROVIDES_FT_GlyphSlot_Embolden
+  FT_Error
+  FT_GlyphSlot_Own_Bitmap( FT_GlyphSlot  slot )
+  {
+    if ( slot && slot->format == FT_GLYPH_FORMAT_BITMAP   &&
+         !( slot->internal->flags & FT_GLYPH_OWN_BITMAP ) )
+    {
+      FT_Bitmap  bitmap;
+      FT_Error   error;
+
+
+      FT_Bitmap_New( &bitmap );
+      error = FT_Bitmap_Copy( slot->library, &slot->bitmap, &bitmap );
+      if ( error )
+        return error;
+
+      slot->bitmap = bitmap;
+      slot->internal->flags |= FT_GLYPH_OWN_BITMAP;
+    }
+
+    return FT_Err_Ok;
+  }
+#endif
+
+
+#ifdef __LSB_PROVIDES_FT_GlyphSlot_Embolden
+  FT_Error
+  FT_Outline_Embolden( FT_Outline*  outline,
+                       FT_Pos       strength )
+  { 
+    FT_Vector*  points; 
+    FT_Vector   v_prev, v_first, v_next, v_cur;
+    FT_Angle    rotate, angle_in, angle_out;
+    FT_Int      c, n, first;
+    FT_Int      orientation;
+
+    
+    if ( !outline )
+      return FT_Err_Invalid_Argument;
+    
+    strength /= 2;
+    if ( strength == 0 )
+      return FT_Err_Ok;
+    
+    orientation = FT_Outline_Get_Orientation( outline );
+    if ( orientation == FT_ORIENTATION_NONE )
+    { 
+      if ( outline->n_contours )
+        return FT_Err_Invalid_Argument;
+      else
+        return FT_Err_Ok;
+    }
+
+    if ( orientation == FT_ORIENTATION_TRUETYPE )
+      rotate = -FT_ANGLE_PI2;
+    else
+      rotate = FT_ANGLE_PI2;
+
+    points = outline->points;
+
+    first = 0;
+    for ( c = 0; c < outline->n_contours; c++ )
+    {
+      int  last = outline->contours[c];
+
+
+      v_first = points[first];
+      v_prev  = points[last];
+     v_cur   = v_first;
+
+      for ( n = first; n <= last; n++ )
+      {
+        FT_Vector  in, out;
+        FT_Angle   angle_diff;
+        FT_Pos     d;
+        FT_Fixed   scale;
+
+
+        if ( n < last )
+          v_next = points[n + 1];
+        else
+          v_next = v_first;
+
+        /* compute the in and out vectors */
+        in.x = v_cur.x - v_prev.x;
+        in.y = v_cur.y - v_prev.y;
+
+        out.x = v_next.x - v_cur.x;
+        out.y = v_next.y - v_cur.y;
+
+        angle_in   = FT_Atan2( in.x, in.y );
+        angle_out  = FT_Atan2( out.x, out.y );
+        angle_diff = FT_Angle_Diff( angle_in, angle_out );
+        scale      = FT_Cos( angle_diff / 2 );
+
+        if ( scale < 0x4000L && scale > -0x4000L )
+          in.x = in.y = 0;
+        else
+        {
+          d = FT_DivFix( strength, scale );
+
+          FT_Vector_From_Polar( &in, d, angle_in + angle_diff / 2 - rotate );
+        }
+
+        outline->points[n].x = v_cur.x + strength + in.x;
+        outline->points[n].y = v_cur.y + strength + in.y;
+
+        v_prev = v_cur;
+        v_cur  = v_next;
+      }
+
+      first = last + 1;
+    }
+
+    return FT_Err_Ok;
+  }
+#endif
+
+
diff --git openjdk-orig/hotspot/lsb/static/lsb_dlfcn.h openjdk/hotspot/lsb/static/lsb_dlfcn.h
new file mode 100644
index 0000000..8642a9a
--- /dev/null
+++ openjdk/hotspot/lsb/static/lsb_dlfcn.h
@@ -0,0 +1,15 @@
+
+#ifndef _LSB_DLFCN_H_OPENJDK_WRAPPER
+#define _LSB_DLFCN_H_OPENJDK_WRAPPER
+
+#ifndef __LSB_PROVIDES_RTLD_NOLOAD
+#define RTLD_NOLOAD 0x00004
+#endif
+
+// dlvsym
+#ifndef __LSB_PROVIDES_dlvsym
+extern void *dlvsym(void *handle, char const *symbol, char const *version);
+#endif
+
+#endif // include sentry
+
diff --git openjdk-orig/hotspot/lsb/static/lsb_flags.c openjdk/hotspot/lsb/static/lsb_flags.c
new file mode 100644
index 0000000..836dfc1
--- /dev/null
+++ openjdk/hotspot/lsb/static/lsb_flags.c
@@ -0,0 +1,3 @@
+
+#include <lsb_flags.h>
+
diff --git openjdk-orig/hotspot/lsb/static/lsb_freetype.h openjdk/hotspot/lsb/static/lsb_freetype.h
new file mode 100644
index 0000000..54e2129
--- /dev/null
+++ openjdk/hotspot/lsb/static/lsb_freetype.h
@@ -0,0 +1,24 @@
+
+/* Include this file if you want to use non-lsb freetype functions */
+
+/* 
+FT_GlyphSlot_Embolden
+FT_GlyphSlot_Oblique
+*/
+
+#ifndef _LSB_FREETYPE_H_OPENJDK_WRAPPER
+#define _LSB_FREETYPE_H_OPENJDK_WRAPPER
+
+#include <ft2build.h>
+#include FT_FREETYPE_H
+
+#ifndef __LSB_PROVIDES_FT_GlyphSlot_Embolden
+void FT_GlyphSlot_Embolden( FT_GlyphSlot  slot );
+#endif
+
+#ifndef __LSB_PROVIDES_FT_GlyphSlot_Oblique
+void FT_GlyphSlot_Oblique( FT_GlyphSlot  slot );
+#endif
+
+#endif
+
diff --git openjdk-orig/hotspot/lsb/static/lsb_pthread.h openjdk/hotspot/lsb/static/lsb_pthread.h
new file mode 100644
index 0000000..30c74d4
--- /dev/null
+++ openjdk/hotspot/lsb/static/lsb_pthread.h
@@ -0,0 +1,14 @@
+
+/* Non-LSB pthread interfaces */
+
+#ifndef _LSB_PTHREAD_H_OPENJDK_WRAPPER
+#define _LSB_PTHREAD_H_OPENJDK_WRAPPER
+
+#include <pthread.h>
+
+#ifndef __LSB_PROVIDES_pthread_getattr_np
+extern int pthread_getattr_np (pthread_t __th, pthread_attr_t *__attr);
+#endif
+
+#endif // include sentry
+
diff --git openjdk-orig/hotspot/lsb/static/lsb_ucontext.h openjdk/hotspot/lsb/static/lsb_ucontext.h
new file mode 100644
index 0000000..4c2b27f
--- /dev/null
+++ openjdk/hotspot/lsb/static/lsb_ucontext.h
@@ -0,0 +1,117 @@
+
+// Becareful not to interfere with LSB's header include sentry!
+#ifndef _LSB_UCONTEXT_H_OPENJDK_WRAPPER
+#define _LSB_UCONTEXT_H_OPENJDK_WRAPPER
+
+#if defined(__alpha) || defined(__alpha__) || \
+    defined(__ia64__) || defined(__powerpc64__) || defined(__s390x__) || \
+    defined(__x86_64__)
+// 64-bit arch
+
+/* Number of general registers.  */
+#define NGREG	23
+
+/* Number of each register in the `gregset_t' array.  */
+enum
+{
+  REG_R8 = 0,
+# define REG_R8		REG_R8
+  REG_R9,
+# define REG_R9		REG_R9
+  REG_R10,
+# define REG_R10	REG_R10
+  REG_R11,
+# define REG_R11	REG_R11
+  REG_R12,
+# define REG_R12	REG_R12
+  REG_R13,
+# define REG_R13	REG_R13
+  REG_R14,
+# define REG_R14	REG_R14
+  REG_R15,
+# define REG_R15	REG_R15
+  REG_RDI,
+# define REG_RDI	REG_RDI
+  REG_RSI,
+# define REG_RSI	REG_RSI
+  REG_RBP,
+# define REG_RBP	REG_RBP
+  REG_RBX,
+# define REG_RBX	REG_RBX
+  REG_RDX,
+# define REG_RDX	REG_RDX
+  REG_RAX,
+# define REG_RAX	REG_RAX
+  REG_RCX,
+# define REG_RCX	REG_RCX
+  REG_RSP,
+# define REG_RSP	REG_RSP
+  REG_RIP,
+# define REG_RIP	REG_RIP
+  REG_EFL,
+# define REG_EFL	REG_EFL
+  REG_CSGSFS,		/* Actually short cs, gs, fs, __pad0.  */
+# define REG_CSGSFS	REG_CSGSFS
+  REG_ERR,
+# define REG_ERR	REG_ERR
+  REG_TRAPNO,
+# define REG_TRAPNO	REG_TRAPNO
+  REG_OLDMASK,
+# define REG_OLDMASK	REG_OLDMASK
+  REG_CR2
+# define REG_CR2	REG_CR2
+};
+
+#else /* else 32 bit arch */
+
+/* Number of general registers.  */
+#define NGREG	19
+
+/* Number of each register is the `gregset_t' array.  */
+enum
+{
+  REG_GS = 0,
+# define REG_GS		REG_GS
+  REG_FS,
+# define REG_FS		REG_FS
+  REG_ES,
+# define REG_ES		REG_ES
+  REG_DS,
+# define REG_DS		REG_DS
+  REG_EDI,
+# define REG_EDI	REG_EDI
+  REG_ESI,
+# define REG_ESI	REG_ESI
+  REG_EBP,
+# define REG_EBP	REG_EBP
+  REG_ESP,
+# define REG_ESP	REG_ESP
+  REG_EBX,
+# define REG_EBX	REG_EBX
+  REG_EDX,
+# define REG_EDX	REG_EDX
+  REG_ECX,
+# define REG_ECX	REG_ECX
+  REG_EAX,
+# define REG_EAX	REG_EAX
+  REG_TRAPNO,
+# define REG_TRAPNO	REG_TRAPNO
+  REG_ERR,
+# define REG_ERR	REG_ERR
+  REG_EIP,
+# define REG_EIP	REG_EIP
+  REG_CS,
+# define REG_CS		REG_CS
+  REG_EFL,
+# define REG_EFL	REG_EFL
+  REG_UESP,
+# define REG_UESP	REG_UESP
+  REG_SS
+# define REG_SS	REG_SS
+};
+
+#endif // arch wordsize
+
+
+#endif //include sentry
+
diff --git openjdk-orig/hotspot/lsb/static/sys/lsb_mman.h openjdk/hotspot/lsb/static/sys/lsb_mman.h
new file mode 100644
index 0000000..cc53196
--- /dev/null
+++ openjdk/hotspot/lsb/static/sys/lsb_mman.h
@@ -0,0 +1,8 @@
+
+#ifndef _SYS_MMAN_H_OPENJDK_WRAPPER
+#define _SYS_MMAN_H_OPENJDK_WRAPPER
+
+extern int mincore (void *__start, size_t __len, unsigned char *__vec);
+
+#endif //include sentry
+
diff --git openjdk-orig/hotspot/lsb/static/syscall_impl.c openjdk/hotspot/lsb/static/syscall_impl.c
new file mode 100644
index 0000000..0d2fabb
--- /dev/null
+++ openjdk/hotspot/lsb/static/syscall_impl.c
@@ -0,0 +1,38 @@
+
+#include <syscall.h>
+#include <lsb_helpers.h>
+
+// syscall can't have helprer due to variable number of arguments.  
+// So we have to call it through pointer.
+int syscall(int,...);
+LSB_CHECKER(DEFAULT,syscall);
+// now pointer syscall_a is available.
+
+int syscall_gettid_available()
+{
+    return syscall_available() && (syscall_gettid() != -1);
+}
+
+#ifndef SYS_gettid
+// i386: 224, ia64: 1105, amd64: 186, sparc 143
+#ifdef __ia64__
+#define SYS_gettid 1105
+#elif __i386__
+#define SYS_gettid 224
+#elif __amd64__
+#define SYS_gettid 186
+#elif __sparc__
+#define SYS_gettid 143
+#else
+#error define gettid for the arch
+#endif
+#endif
+
+int syscall_gettid()
+{
+    //To load address we must check availability
+    syscall_available();
+    //now syscall
+    return (*syscall_a)(SYS_gettid);
+}
+
diff --git openjdk-orig/hotspot/make/linux/makefiles/defs.make openjdk/hotspot/make/linux/makefiles/defs.make
index 39321fb..0aa3559 100644
--- openjdk-orig/hotspot/make/linux/makefiles/defs.make
+++ openjdk/hotspot/make/linux/makefiles/defs.make
@@ -135,3 +135,9 @@ else
 endif
 endif
 endif
+
+#Lsb exports
+ifdef OPENJDK_LSB_VERSION
+#Directiry for overrides for non-lsb header files
+LSB_INCLUDE_AUX= -I$(GAMMADIR)/lsb/include -I$(GAMMADIR)/lsb
+endif
diff --git openjdk-orig/hotspot/make/linux/makefiles/gcc.make openjdk/hotspot/make/linux/makefiles/gcc.make
index 5701dd4..6701e95 100644
--- openjdk-orig/hotspot/make/linux/makefiles/gcc.make
+++ openjdk/hotspot/make/linux/makefiles/gcc.make
@@ -179,3 +179,16 @@ DEBUG_CFLAGS += $(DEBUG_CFLAGS/$(BUILDARCH))
 ifeq ($(DEBUG_CFLAGS/$(BUILDARCH)),)
 DEBUG_CFLAGS += -gstabs
 endif
+
+#------------------------------------------------------------------------
+# LSB overrides
+
+ifdef OPENJDK_LSB_VERSION
+CPP = /opt/lsb/bin/lsbc++ $(LSB_INCLUDE_AUX)
+CC  = /opt/lsb/bin/lsbcc $(LSB_INCLUDE_AUX)
+
+# Don't link standard libs statically -- LSB takes care of stability
+STATIC_STDCXX= 
+STATIC_LIBGCC= 
+endif
+
diff --git openjdk-orig/hotspot/make/linux/makefiles/launcher.make openjdk/hotspot/make/linux/makefiles/launcher.make
index e367409..091e72c 100644
--- openjdk-orig/hotspot/make/linux/makefiles/launcher.make
+++ openjdk/hotspot/make/linux/makefiles/launcher.make
@@ -71,3 +71,9 @@ $(LAUNCHER): $(LAUNCHER.o) $(LIBJVM) $(LAUNCHER_MAPFILE)
 	    $(LINK_LAUNCHER) $(LFLAGS_LAUNCHER) -o $@ $(LAUNCHER.o) $(LIBS_LAUNCHER); \
 	    $(LINK_LAUNCHER/POST_HOOK) \
         }
+
+ifdef OPENJDK_LSB_VERSION
+# It's in the draft, TODO: is it needed? Probably, to compile C++ code with gcc.
+LIBS_LAUNCHER += -lstdc++ -lrt -lgcc_s
+endif
+
diff --git openjdk-orig/hotspot/make/linux/makefiles/lsb.make openjdk/hotspot/make/linux/makefiles/lsb.make
new file mode 100644
index 0000000..2bc51ff
--- /dev/null
+++ openjdk/hotspot/make/linux/makefiles/lsb.make
@@ -0,0 +1,72 @@
+#
+# Copyright 2005-2008 Sun Microsystems, Inc.  All Rights Reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa Clara,
+# CA 95054 USA or visit www.sun.com if you need additional information or
+# have any questions.
+#  
+#
+
+# Rules to build LSB compatibility helpers
+
+ifndef OPENJDK_LSB_VERSION
+# If we're not making LSB build, do nothing
+.PHONY: all
+all:
+	@echo Not LSB build: OPENJDK_LSB_VERSION=$(OPENJDK_LSB_VERSION)
+
+else
+
+LIBLSB = liblsb_helper_hotspot7.a
+LSBSRCDIR = $(GAMMADIR)/lsb
+LSB_INCLUDE_AUX = -I$(LSBSRCDIR)/include -I$(LSBSRCDIR)
+DEST_LSB  = $(JDK_LIBDIR)/$(LIBLSB)
+
+LSB_SRC_FILES = lsb_helpers.c \
+    lsb_wrappers.c \
+    static/syscall_impl.c 
+
+#$(LIBLSB): $(addprefix $(LSBSRCDIR)/,$(patsubst %.c,%.o,$(LSB_SRC_FILES)))
+$(LIBLSB): $(patsubst %.c,%.o,$(notdir $(LSB_SRC_FILES)))
+	@echo Making LSB compatibility helper library...
+	ar rcs liblsb_helper_hotspot7.a $^
+
+# implicit rules to make object files out of $(LSB_SRC_FILS)
+%.o: %.c
+	$(QUIETLY) $(CC) -c $< $(LSB_INCLUDE_AUX)
+vpath %.c $(LSBSRCDIR)
+vpath %.c $(LSBSRCDIR)/static
+
+install_lsb: $(LIBLSB)
+	@echo "Copying $(LIBLSB) to $(DEST_LSB)"
+	$(QUIETLY) cp -f $(LIBLSB) $(DEST_LSB) && echo "Done"
+
+.PHONY: install_lsb
+
+# We also add dependencies on LSB helpers here in sake of easier merges!
+
+# Serviceability agent needs helpers
+$(LIBJVM_DB): $(LIBLSB)
+# Launcher also needs them
+LIBS_LAUNCHER+= -llsb_helper_hotspot7
+
+# Common targets
+build: $(LIBLSB)
+install: install_lsb
+
+endif
diff --git openjdk-orig/hotspot/make/linux/makefiles/saproc.make openjdk/hotspot/make/linux/makefiles/saproc.make
index 84b8dc6..d6d22d1 100644
--- openjdk-orig/hotspot/make/linux/makefiles/saproc.make
+++ openjdk/hotspot/make/linux/makefiles/saproc.make
@@ -53,6 +53,8 @@ checkAndBuildSA:
 
 SA_LFLAGS = $(MAPFLAG:FILENAME=$(SAMAPFILE))
 
+SA_LIBTHREAD_DB = -lthread_db
+
 $(LIBSAPROC): $(SASRCFILES) $(SAMAPFILE)
 	$(QUIETLY) if [ "$(BOOT_JAVA_HOME)" = "" ]; then \
 	  echo "ALT_BOOTDIR, BOOTDIR or JAVA_HOME needs to be defined to build SA"; \
@@ -68,7 +70,7 @@ $(LIBSAPROC): $(SASRCFILES) $(SAMAPFILE)
 	           $(SASRCFILES)                                        \
 	           $(SA_LFLAGS)                                         \
 	           -o $@                                                \
-	           -lthread_db
+	           $(SA_LIBTHREAD_DB)
 
 install_saproc: checkAndBuildSA
 	$(QUIETLY) if [ -e $(LIBSAPROC) ] ; then             \
@@ -76,4 +78,8 @@ install_saproc: checkAndBuildSA
 	  cp -f $(LIBSAPROC) $(DEST_SAPROC) && echo "Done";  \
 	fi
 
+ifdef OPENJDK_LSB_VERSION
+SA_LIBTHREAD_DB= -L `pwd` -llsb_helper_hotspot7 -I$(GAMMADIR)/lsb/include -I$(GAMMADIR)/lsb
+endif
+
 .PHONY: checkAndBuildSA install_saproc
diff --git openjdk-orig/hotspot/make/linux/makefiles/vm.make openjdk/hotspot/make/linux/makefiles/vm.make
index 01e2afe..cfbea2f 100644
--- openjdk-orig/hotspot/make/linux/makefiles/vm.make
+++ openjdk/hotspot/make/linux/makefiles/vm.make
@@ -240,6 +240,17 @@ include $(MAKEFILES_DIR)/jsig.make
 # Serviceability agent
 include $(MAKEFILES_DIR)/saproc.make
 
+# LSB compatibility helpers
+include $(MAKEFILES_DIR)/lsb.make
+
+# Also, let's spit out a couple of LSB defs
+ifdef OPENJDK_LSB_VERSION
+STATIC_CXX=false
+LIBS_VM+= -lgcc_s -lstdc++ -lrt
+# Linking lsb helper statically
+LIBS_VM+= -L `pwd` -Wl,-Bstatic -llsb_helper_hotspot7 -Wl,-Bdynamic
+endif
+
 #----------------------------------------------------------------------
 
 build: $(LIBJVM) $(LAUNCHER) $(LIBJSIG) $(LIBJVM_DB) checkAndBuildSA
diff --git openjdk-orig/hotspot/src/os/linux/vm/attachListener_linux.cpp openjdk/hotspot/src/os/linux/vm/attachListener_linux.cpp
index f40ac8e..7381637 100644
--- openjdk-orig/hotspot/src/os/linux/vm/attachListener_linux.cpp
+++ openjdk/hotspot/src/os/linux/vm/attachListener_linux.cpp
@@ -316,6 +316,7 @@ LinuxAttachOperation* LinuxAttachListener::read_request(int s) {
 // In the Linux implementation there is only a single operation and clients
 // cannot queue commands (except at the socket level).
 //
+#include <lsb_flags.h>
 LinuxAttachOperation* LinuxAttachListener::dequeue() {
   for (;;) {
     int s;
diff --git openjdk-orig/hotspot/src/os/linux/vm/hpi_linux.hpp openjdk/hotspot/src/os/linux/vm/hpi_linux.hpp
index b671a4e..6d64cd1 100644
--- openjdk-orig/hotspot/src/os/linux/vm/hpi_linux.hpp
+++ openjdk/hotspot/src/os/linux/vm/hpi_linux.hpp
@@ -28,8 +28,8 @@
 //
 
 #include <unistd.h>
+#include <poll.h>
 #include <sys/socket.h>
-#include <sys/poll.h>
 #include <sys/ioctl.h>
 #include <netdb.h>
 
diff --git openjdk-orig/hotspot/src/os/linux/vm/os_linux.cpp openjdk/hotspot/src/os/linux/vm/os_linux.cpp
index e2e7347..1b3f03a 100644
--- openjdk-orig/hotspot/src/os/linux/vm/os_linux.cpp
+++ openjdk/hotspot/src/os/linux/vm/os_linux.cpp
@@ -26,6 +26,7 @@
 # include "incls/_os_linux.cpp.incl"
 
 // put OS-includes here
+# include <alloca.h>
 # include <sys/types.h>
 # include <sys/mman.h>
 # include <pthread.h>
@@ -53,6 +54,7 @@
 # include <sys/ipc.h>
 # include <sys/shm.h>
 # include <link.h>
+# include <elf.h>
 
 #define MAX_PATH    (2 * K)
 
@@ -60,6 +62,15 @@
 #define ALL_64_BITS CONST64(0xFFFFFFFFFFFFFFFF)
 #define SEC_IN_NANOSECS  1000000000LL
 
+// This file is lsb-dependent
+#include <lsb_config.h>
+#include <lsb_wrappers.h>
+// Also include LSB flags overrides
+#include <lsb_flags.h>
+#ifdef __LSB_VERSION__
+#include <libgen.h>
+#endif
+
 ////////////////////////////////////////////////////////////////////////////////
 // global variables
 julong os::Linux::_physical_memory = 0;
@@ -202,7 +213,17 @@ static char cpu_arch[] = "sparc";
 // on NPTL, it returns the same pid for all threads, as required by POSIX.)
 //
 pid_t os::Linux::gettid() {
+#ifdef __LSB_PROVIDES_syscall_gettid
   int rslt = syscall(SYS_gettid);
+#else
+  int rslt = -1;
+  if (syscall_gettid_available()){
+      rslt = syscall_gettid();
+  }
+  if (rslt = -1){ //we still haven't gotten tid? I guess, syscall hasn't succeeded.
+      rslt = pthread_self();
+  }
+#endif
   if (rslt == -1) {
      // old kernel, no NPTL support
      return getpid();
@@ -223,7 +244,12 @@ static const char *unstable_chroot_error = "/proc file system not found.\n"
 void os::Linux::initialize_system_info() {
   _processor_count = sysconf(_SC_NPROCESSORS_CONF);
   if (_processor_count == 1) {
-    pid_t pid = os::Linux::gettid();
+    pid_t pid;
+    if (syscall_gettid_available()){
+       pid = os::Linux::gettid();
+    }else{
+       pid = getpid();
+    }
     char fname[32];
     jio_snprintf(fname, sizeof(fname), "/proc/%d", pid);
     FILE *fp = fopen(fname, "r");
@@ -548,8 +574,15 @@ void os::Linux::libpthread_init() {
   } else {
      // _CS_GNU_LIBC_VERSION is not supported, try gnu_get_libc_version()
      static char _gnu_libc_version[32];
+#ifndef __LSB_VERSION__
      jio_snprintf(_gnu_libc_version, sizeof(_gnu_libc_version),
               "glibc %s %s", gnu_get_libc_version(), gnu_get_libc_release());
+#else
+#define __OPENJDK_MACRO_STRINGIFY__(xxx) #xxx
+     jio_snprintf(_gnu_libc_version, sizeof(_gnu_libc_version),
+              "glibc is provided by LSBv%s", __OPENJDK_MACRO_STRINGIFY__(__LSB_VERSION__) );
+#undef __OPENJDK_MACRO_STRINGIFY__
+#endif
      os::Linux::set_glibc_version(_gnu_libc_version);
   }
 
@@ -1339,7 +1372,7 @@ void os::Linux::clock_init() {
 
 #endif
 
-#define sys_clock_getres(x,y)  ::syscall(SYS_clock_getres, x, y)
+#define sys_clock_getres(x,y)  ::clock_getres(x, y)
 
 void os::Linux::fast_thread_clock_init() {
   if (!UseLinuxPosixThreadCPUClocks) {
@@ -1579,6 +1612,10 @@ struct _address_to_library_name {
   address base;          //         library base addr
 };
 
+/* A copuple of noted on the fixes below.  OpenJDK uses non-lsb function
+dl_iterate_phdr to workaround bug in dlopen.  LSB 4.1 will contain test
+for this bug and no workaround wil be needed */
+#ifndef __LSB_VERSION__
 static int address_to_library_name_callback(struct dl_phdr_info *info,
                                             size_t size, void *data) {
   int i;
@@ -1615,10 +1652,12 @@ static int address_to_library_name_callback(struct dl_phdr_info *info,
   }
   return 0;
 }
+#endif
 
 bool os::dll_address_to_library_name(address addr, char* buf,
                                      int buflen, int* offset) {
   Dl_info dlinfo;
+#ifndef __LSB_VERSION__
   struct _address_to_library_name data;
 
   // There is a bug in old glibc dladdr() implementation that it could resolve
@@ -1631,12 +1670,18 @@ bool os::dll_address_to_library_name(address addr, char* buf,
   data.buflen = buflen;
   data.base = NULL;
   int rslt = dl_iterate_phdr(address_to_library_name_callback, (void *)&data);
-
   if (rslt) {
      // buf already contains library name
      if (offset) *offset = addr - data.base;
      return true;
-  } else if (dladdr((void*)addr, &dlinfo)){
+  } else  //that's NOT a typo--see below!
+#else
+  // LSB 4.1 compatible distribution shall pass a test that prevents us from
+  // encountering a bug described above.
+  int rslt = 0;
+#endif
+  // IF should be the first statement here--see above!
+  if (dladdr((void*)addr, &dlinfo)){
      if (buf) jio_snprintf(buf, buflen, "%s", dlinfo.dli_fname);
      if (offset) *offset = addr - (address)dlinfo.dli_fbase;
      return true;
@@ -1651,9 +1696,34 @@ bool os::dll_address_to_library_name(address addr, char* buf,
   // in case of error it checks if .dll/.so was built for the
   // same architecture as Hotspot is running on
 
+#ifdef __LSB_VERSION__
+// Libs that are loaded with RTLD_NOW
+// must end with NULL
+// Each library's name should contain `lib' prefix, but no .so or suffixes like this.
+char const* load_now_libs[] = {
+    "libjsound",
+NULL};
+#endif
+
 void * os::dll_load(const char *filename, char *ebuf, int ebuflen)
 {
+#ifndef __LSB_VERSION__
   void * result= ::dlopen(filename, RTLD_LAZY);
+#else
+  // Some libraries are loaded with RTLD_NOW.  Check if it's the case.
+  void * result;
+  char const*const* i;  //pointer to the library
+  for (i = load_now_libs; *i ; i++){
+    // We compare only common prefix starting from the file name of filename
+    if (strncmp(basename(strdup(filename)),*i,strlen(*i)) == 0) break;
+  }
+  if (*i){
+    result= ::dlopen(filename, RTLD_NOW);
+  }else{
+    result= ::dlopen(filename, RTLD_LAZY);
+  }
+#endif
+
   if (result != NULL) {
     // Successful loading
     return result;
@@ -1849,7 +1919,12 @@ void os::print_dll_info(outputStream *st) {
    st->print_cr("Dynamic libraries:");
 
    char fname[32];
-   pid_t pid = os::Linux::gettid();
+   pid_t pid;
+   if (syscall_gettid_available()){
+      pid = os::Linux::gettid();
+   }else{
+      pid = getpid();
+   }
 
    jio_snprintf(fname, sizeof(fname), "/proc/%d/maps", pid);
 
@@ -2927,8 +3002,13 @@ static int prio_init() {
 OSReturn os::set_native_priority(Thread* thread, int newpri) {
   if ( !UseThreadPriorities || ThreadPriorityPolicy == 0 ) return OS_OK;
 
-  int ret = setpriority(PRIO_PROCESS, thread->osthread()->thread_id(), newpri);
-  return (ret == 0) ? OS_OK : OS_ERR;
+  if (syscall_gettid_available()){
+    int ret = setpriority(PRIO_PROCESS, thread->osthread()->thread_id(), newpri);
+    return (ret == 0) ? OS_OK : OS_ERR;
+  }else{
+    // If we didn't syscall, then always return error.
+    return OS_ERR;
+  }
 }
 
 OSReturn os::get_native_priority(const Thread* const thread, int *priority_ptr) {
@@ -2937,9 +3017,14 @@ OSReturn os::get_native_priority(const Thread* const thread, int *priority_ptr)
     return OS_OK;
   }
 
-  errno = 0;
-  *priority_ptr = getpriority(PRIO_PROCESS, thread->osthread()->thread_id());
-  return (*priority_ptr != -1 || errno == 0 ? OS_OK : OS_ERR);
+  if (syscall_gettid_available()){
+    errno = 0;
+    *priority_ptr = getpriority(PRIO_PROCESS, thread->osthread()->thread_id());
+    return (*priority_ptr != -1 || errno == 0 ? OS_OK : OS_ERR);
+  }else{
+    // If we didn't syscall, then always return error.
+    return OS_ERR;
+  }
 }
 
 // Hint to the underlying OS that a task switch would not be good.
@@ -3048,7 +3133,7 @@ static int SR_initialize() {
   /* Get signal number to use for suspend/resume */
   if ((s = ::getenv("_JAVA_SR_SIGNUM")) != 0) {
     int sig = ::strtol(s, 0, 10);
-    if (sig > 0 || sig < _NSIG) {
+    if (sig > 0 && sig < NSIG) {
         SR_signum = sig;
     }
   }
@@ -4084,7 +4169,11 @@ static clockid_t thread_cpu_clockid(Thread* thread) {
 
 jlong os::current_thread_cpu_time() {
   if (os::Linux::supports_fast_thread_cpu_time()) {
-    return os::Linux::fast_thread_cpu_time(CLOCK_THREAD_CPUTIME_ID);
+    clockid_t clockid;
+    if (clock_getcpuclockid(0,&clockid) != 0){
+        return -1;
+    }
+    return os::Linux::fast_thread_cpu_time(clockid);
   } else {
     // return user + sys since the cost is the same
     return slow_thread_cpu_time(Thread::current(), true /* user + sys */);
@@ -4102,7 +4191,11 @@ jlong os::thread_cpu_time(Thread* thread) {
 
 jlong os::current_thread_cpu_time(bool user_sys_cpu_time) {
   if (user_sys_cpu_time && os::Linux::supports_fast_thread_cpu_time()) {
-    return os::Linux::fast_thread_cpu_time(CLOCK_THREAD_CPUTIME_ID);
+    clockid_t clockid;
+    if (clock_getcpuclockid(0,&clockid) != 0){
+        return -1;
+    }
+    return os::Linux::fast_thread_cpu_time(clockid);
   } else {
     return slow_thread_cpu_time(Thread::current(), user_sys_cpu_time);
   }
@@ -4735,8 +4828,23 @@ int os::fork_and_exec(char* cmd) {
   // separate process to execve. Make a direct syscall to fork process.
   // On IA64 there's no fork syscall, we have to use fork() and hope for
   // the best...
+#if (!defined __LSB_PROVIDES_syscall_fork) || (!defined __LSB_PROVIDES_syscall_exevce)
+  // Notes from LSB-OpenJDK project:
+  // This procedure is used only in emergency -- when calling gdb for a 
+  // crashing VM.  For other purposes the usual fork/exec calls are used.
+  // Async-safe messup described above and below is just not true -- it's 
+  // widely known that immediate exec() after fork() is totally async-safe.
+  //
+  // The reason for syscalls might be that calling atfork_handlers in a 
+  // _crashing_ program may arise even more crashing stuff and mess things
+  // up completely.  I don't see any comment on this.  So, I suppose, that
+  // is not the case, and just replace syscall with usual fork()/exec()
+  // calls.
+  pid_t pid = fork();
+#else
   pid_t pid = NOT_IA64(syscall(__NR_fork);)
               IA64_ONLY(fork();)
+#endif
 
   if (pid < 0) {
     // fork failed
@@ -4752,8 +4860,13 @@ int os::fork_and_exec(char* cmd) {
     // in the new process, so make a system call directly.
     // IA64 should use normal execve() from glibc to match the glibc fork()
     // above.
+#if (!defined __LSB_PROVIDES_syscall_fork) || (!defined __LSB_PROVIDES_syscall_exevce)
+    // See notes above
+    execve("/bin/sh", (char* const*)argv, environ);
+#else
     NOT_IA64(syscall(__NR_execve, "/bin/sh", argv, environ);)
     IA64_ONLY(execve("/bin/sh", (char* const*)argv, environ);)
+#endif
 
     // execve failed
     _exit(-1);
diff --git openjdk-orig/hotspot/src/os/linux/vm/os_linux.inline.hpp openjdk/hotspot/src/os/linux/vm/os_linux.inline.hpp
index 6f6d608..1de8128 100644
--- openjdk-orig/hotspot/src/os/linux/vm/os_linux.inline.hpp
+++ openjdk/hotspot/src/os/linux/vm/os_linux.inline.hpp
@@ -83,7 +83,7 @@ inline DIR* os::opendir(const char* dirname)
 
 inline int os::readdir_buf_size(const char *path)
 {
-  return NAME_MAX + sizeof(dirent) + 1;
+  return pathconf(path,_PC_NAME_MAX) + sizeof(dirent) + 1;
 }
 
 inline struct dirent* os::readdir(DIR* dirp, dirent *dbuf)
